tbb::internal::allocate_continuation_proxy Class Reference

`#include <task.h>`

Inheritance diagram for tbb::internal::allocate_continuation_proxy:
Collaboration diagram for tbb::internal::allocate_continuation_proxy:

## Public Member Functions

task &__TBB_EXPORTED_METHOD | allocate (size_t size) const
void __TBB_EXPORTED_METHOD | free (task &) const

## Additional Inherited Members

Private Member Functions inherited from tbb::internal::no_assign
void | operator= (const no_assign &)=delete
| no_assign (const no_assign &)=default
| no_assign ()=default

## Detailed Description

Definition at line 170 of file task.h.

## Member Function Documentation

## allocate()

task & tbb::internal::allocate_continuation_proxy::allocate | ( | size_t | size | ) | const

Definition at line 96 of file task.cpp.

{
task* t = (task*)this;
assert_task_valid(t);
generic_scheduler* s = governor::local_scheduler_weak();
task* parent = t->parent();
t->prefix().parent = NULL;
return s->allocate_task( size, __TBB_CONTEXT_ARG(parent, t->prefix().context) );
}
__TBB_CONTEXT_ARG
#define __TBB_CONTEXT_ARG(arg1, context)
Definition: scheduler_common.h:60
s
void const char const char int ITT_FORMAT __itt_group_sync s
Definition: ittnotify_static.h:91
task
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task * task
Definition: ittnotify_static.h:119
parent
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task __itt_model_task_instance ITT_FORMAT p void ITT_FORMAT p void ITT_FORMAT p void size_t ITT_FORMAT d void ITT_FORMAT p const wchar_t ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s no args void ITT_FORMAT p size_t ITT_FORMAT d no args const wchar_t const wchar_t ITT_FORMAT s __itt_heap_function void size_t int ITT_FORMAT d __itt_heap_function void ITT_FORMAT p __itt_heap_function void void size_t int ITT_FORMAT d no args no args unsigned int ITT_FORMAT u const __itt_domain __itt_id ITT_FORMAT lu const __itt_domain __itt_id __itt_id parent
Definition: ittnotify_static.h:176
size
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t size
Definition: ittnotify_static.h:109
tbb::internal::assert_task_valid
void assert_task_valid(const task *)
Definition: scheduler_common.h:237
tbb::internal::governor::local_scheduler_weak
static generic_scheduler * local_scheduler_weak()
Definition: governor.h:134
tbb::internal::generic_scheduler
Work stealing task scheduler.
Definition: scheduler.h:140

References __TBB_CONTEXT_ARG, tbb::internal::assert_task_valid(), tbb::internal::task_prefix::context, tbb::internal::governor::local_scheduler_weak(), tbb::internal::task_prefix::parent, tbb::task::parent(), parent, tbb::task::prefix(), s, and size.

Referenced by tbb::interface9::internal::allocate_sibling().

Here is the call graph for this function:
Here is the caller graph for this function:

## free()

void tbb::internal::allocate_continuation_proxy::free | ( | task & | mytask | ) | const

Definition at line 105 of file task.cpp.

{
// Restore the parent as it was before the corresponding allocate was called.
((task*)this)->prefix().parent = mytask.parent();
governor::local_scheduler_weak()->free_task<local_task>(mytask);
}
tbb::internal::local_task
@ local_task
Task is known to have been allocated by this scheduler.
Definition: scheduler_common.h:190
tbb::internal::generic_scheduler::free_task
void free_task(task &t)
Put task on free list.
Definition: scheduler.h:730

References tbb::internal::generic_scheduler::free_task(), tbb::internal::governor::local_scheduler_weak(), tbb::internal::local_task, and tbb::task::parent().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- task.h
- task.cpp

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.